package polyglot.ext.op;

import polyglot.ext.jl.types.*;
import polyglot.types.*;
import polyglot.util.InternalCompilerError;
import java.util.*;

/**
 * An <code>PrimitiveType_c</code> represents a primitive type.
 */
public class OPPrimitiveType_c extends PrimitiveType_c
{
    /** Used for deserializing types. */
    protected OPPrimitiveType_c() { }

    public OPPrimitiveType_c(Kind kind) {
        super(ts, kind);
    }

    public boolean descendsFromImpl(Type ancestor) {
        return ts.equals(ancestor, ts.Object());
    }

    public boolean isImplicitCastValidImpl(Type toType) {
        return ts.equals(toType, ts.Object()) ||
               super.isImplicitCastValidImpl(toType);
    }

    /**
     * Requires: all type arguments are canonical.  ToType is not a NullType.
     *
     * Returns true iff a cast from this to toType is valid; in other
     * words, some non-null members of this are also members of toType.
     */
    public boolean isCastValidImpl(Type toType) {
        return ts.equals(toType, ts.Object()) || super.isCastValidImpl(toType);
    }
}
