package polyglot.ext.polyj.util;

import polyglot.types.*;
import polyglot.util.*;
import polyglot.ext.polyj.types.*;
import polyglot.ext.polyj.util.*;
import polyglot.ext.polyj.visit.*;

public class StaticFieldBinding_c implements StaticFieldBinding {
    protected FieldInstance fi;
    protected String name;
    protected String get;
    protected String set;
    

    public StaticFieldBinding_c(ClassType enclosingType, FieldInstance fi) {
        this.fi = fi;
        this.name = fi.name();
        PolyJTypeSystem ts = (PolyJTypeSystem) enclosingType.typeSystem();
        this.get = PolyJTranslator.adapterMethodName("s_get", enclosingType, 
            ts, name);
        this.set = PolyJTranslator.adapterMethodName("s_set", enclosingType, 
            ts, name);        
    }

    public FieldInstance fieldInstance() {
        return fi;
    }

    public String get() { 
        return get; 
    }
    
    public String set() { 
        return set; 
    }
    
    public String prot_get() {
        return "get_" + name;
    }
    
    public String prot_set() {
        return "set_" + name;
    }
}
